# File tres/Scripts/tcemsao.cl
# March 29, 2008
# By Doug Mink, SAO Telescope Data Center

# TCEMSAO - Run pemsao on a calibration image

procedure tcemsao (images)

string  images=""       {prompt="Images to process"}

bool	curmode=no	{prompt="Stop after each order (yes or no)"}

struct *calfiles

begin
    file imin, templist, imout

    string ims

    ims = images

    if (!deftask ("pemsao")) {
	rvsao (motd=no)
	}

    pemsao.specnum = "1-51"
    pemsao.specband = 0
    pemsao.skynum = "0"
    pemsao.skyband = 0
    pemsao.specdir = ""
    pemsao.linefit = yes
    pemsao.fixbad = no
    pemsao.badlines = "badlines.dat"
    pemsao.renormalize = no
    pemsao.st_lambda = -10.
    pemsao.end_lambda = -10.
    pemsao.nsmooth = 10
    pemsao.vel_init = "guess"
    pemsao.czguess = 0.
    pemsao.cortemp = ""
    pemsao.wspan = 1.
    pemsao.linesig = 1.5
    pemsao.emsearch = ""
    pemsao.emlines = "tharlines.dat"
    pemsao.linedir = "tres$lib"
    pemsao.npfit = 3
    pemsao.nlcont = 1
    pemsao.esmooth = 0
    pemsao.emcombine = "tharcomb.dat"
    pemsao.mincont = 0.
    pemsao.lwmin = 0.4
    pemsao.lwmax = 1.7
    pemsao.lsmin = 1.
    pemsao.sigline = 0.
    pemsao.disperr = 0.01
    pemsao.vel_corr = "none"
    pemsao.report_mode = 12
    pemsao.archive = no
    pemsao.save_vel = no
    pemsao.verbose = yes
    pemsao.logfiles = "STDOUT,emsao.log"
    pemsao.device = "stdgraph"
    pemsao.hardcopy = no
    pemsao.displot = yes
    pemsao.plotter = "stdplot"
    pemsao.dispmode = 2
    pemsao.vel_plot = "emission"
    pemsao.curmode = curmode
    pemsao.dispem = yes
    pemsao.dispabs = no
    pemsao.ablines = ""
    pemsao.obj_plot = no
    pemsao.contsub_plot = no
    pemsao.debug = no
    pemsao.nsum = 1
    pemsao.cursor = ""

#  Make temporary list of input files
    templist = mktemp ("tempcomp") // ".list"
    files (ims, >templist)

    calfiles = templist
    while (fscan (calfiles, imin) != EOF) {

	pemsao (imin)
	print ("TCEMSAO: ",imin,": ",pemsao.nlfit," lines, vel=",pemsao.meanvel," +-",pemsao.meanerr)

	}

    calfiles = ""
    delete (templist)
end
